---
product: "AG Studio"
title: "Filters"
description: "Filters change the data shown on a Page or Widget."
framework: javascript
version: "3.0.0"
related:
    - title: "Data Setup"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/data-setup/"
    - title: "Using Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/using-data/"
    - title: "Calculations"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/creating-calculations/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Filters

Filters change the data shown on a Page or Widget.

Filters can be applied in a few different ways. Page and Widget Filters can be added in the Filters Panel, Filter Widgets can be used on the layout, or cross-filtering can be applied by interacting with a Widget. When Filter Widgets or cross-filtering apply a condition, it appears in the Filters Panel as a read-only card.

There are four types of filters in AG Studio:

- **Page Filters** - apply to all Widgets on the page and are managed in the Filters Panel,
- **Widget Filters** - apply only to a specific Widget and are managed in the Filters Panel,
- **Cross-filtering** - filters driven by interacting with a Widget,
- **Filter Widgets** - on-canvas filter controls that apply a page filter and appear as a read-only card in the Page Filters section.

## Filters Panel

The Filters Panel provides a centralised space for managing all filter types. Filters are presented as cards, organised by type.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#modes), filters can be added, removed, and reordered by dragging filter cards within a section. In [View Mode](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#modes), the configuration of Page Filters and Widget Filters can be changed, but by default filters cannot be added or removed - your developer can enable this. Read-only cards, such as those for Filter Widgets and cross-filtering conditions, can always be removed from the Filters Panel regardless of mode.

Filter Widgets and cross-filtering conditions appear as read-only, collapsed cards, so the report user can see at a glance what is affecting the data display. Clicking a Widget Filter or Cross Filter card puts the origin Widget into focus.

### Applying Filter Changes

By default, a change to a filter card takes effect straight away and the page updates as you type.

Your developer can instead configure the Filters Panel so that changes are held until you confirm them. In that case each expanded filter card shows **Apply** and **Cancel** buttons at the bottom. Nothing on the page changes until you press Apply, and Cancel returns the card to the values that were last applied. This suits reports whose data is fetched from a server, where every keystroke would otherwise start a new query.

A card holding changes you have not applied yet is marked with an edit indicator in its header, so you can still see which filters are pending while the cards are collapsed. A collapsed card always describes the filter that is actually applied, not the change you are part-way through making.

Two behaviours are worth knowing about. A filter that is only partly filled in - the start of a range with no end, for example - does not count as a filter at all, so Apply stays greyed out until the condition is complete. And clearing one end of a range that has already been applied removes the filter, because the remaining condition is incomplete.

The example below is in View Mode and opens with a region Page Filter and a date Page Filter already applied, both cards expanded so the button row is visible. The report is configured with `applyOnChange: false`, so changing a card's values holds the edit rather than applying it - add or remove a region and the Widgets stay as they are until Apply is pressed. Cancel restores the values that were last applied.

#### Staged Filter Changes

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "kpi-net-sales": {
          type: "value",
          dataMapping: { value: [{ id: "net_sales" }] },
          format: { caption: { enabled: true, text: "Net Sales" } },
        },
        "kpi-order-count": {
          type: "value",
          dataMapping: { value: [{ id: "order_count" }] },
          format: { caption: { enabled: true, text: "Order Count" } },
        },
        "kpi-aov": {
          type: "value",
          dataMapping: { value: [{ id: "average_order_value" }] },
          format: { caption: { enabled: true, text: "Avg Order Value" } },
        },
        "net-sales-by-region": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: { title: { enabled: true, text: "Net Sales by Region" } },
        },
        "net-sales-by-subcategory": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: { enabled: true, text: "Net Sales by Subcategory" },
          },
        },
      },
      widgetLayout: {
        "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
        "net-sales-by-region": { xTrack: 0, yTrack: 6, xSpan: 24, ySpan: 18 },
        "net-sales-by-subcategory": {
          xTrack: 0,
          yTrack: 24,
          xSpan: 24,
          ySpan: 18,
        },
      },
      filter: {
        // Both cards start expanded and already applied, so the Apply and Cancel buttons
        // are visible on load without the reader having to add a filter first.
        page: [
          {
            field: { id: "stores.region" },
            view: { expanded: true, viewTypeId: "selection" },
            model: {
              operator: "isIn",
              value: ["DACH", "UK"],
            },
          },
          {
            field: { id: "orders.order_datetime" },
            view: { expanded: true },
            model: {
              operator: "greaterThan",
              value: "2024-12-01",
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "view",
  initialState,
  panels: {
    // An options-only config leaves each mode's default panels in place, so view mode still
    // shows the filters panel on the right.
    options: {
      filters: { applyOnChange: false },
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Staged Filter Changes](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/staged-filters/typescript/)

## Page Filters

Page Filters apply to all Widgets on the current page. Page Filters should be used when a consistent slice of data is required across the whole page (for example, a single region or date range).

The example below shows a page with a date Page Filter applied. The filter affects all Widgets on the page - the KPIs and both bar charts (Net Sales by Region and Net Sales by Subcategory) all reflect the same filtered data.

#### Page Filters

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "kpi-net-sales": {
          type: "value",
          dataMapping: { value: [{ id: "net_sales" }] },
          format: { caption: { enabled: true, text: "Net Sales" } },
        },
        "kpi-order-count": {
          type: "value",
          dataMapping: { value: [{ id: "order_count" }] },
          format: { caption: { enabled: true, text: "Order Count" } },
        },
        "kpi-aov": {
          type: "value",
          dataMapping: { value: [{ id: "average_order_value" }] },
          format: { caption: { enabled: true, text: "Avg Order Value" } },
        },
        "net-sales-by-region": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: { title: { enabled: true, text: "Net Sales by Region" } },
        },
        "net-sales-by-subcategory": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: { enabled: true, text: "Net Sales by Subcategory" },
          },
        },
      },
      widgetLayout: {
        "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
        "net-sales-by-region": { xTrack: 0, yTrack: 6, xSpan: 24, ySpan: 18 },
        "net-sales-by-subcategory": {
          xTrack: 0,
          yTrack: 24,
          xSpan: 24,
          ySpan: 18,
        },
      },
      filter: {
        page: [
          {
            field: { id: "orders.order_datetime" },
            view: { expanded: true },
            model: {
              operator: "greaterThan",
              value: "2024-12-01",
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["filters"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Page Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/page-filters/typescript/)

## Widget Filters

Widget Filters apply only to one Widget. Widget Filters should be used when a Widget needs a different scope from the rest of the page (for example, one chart showing "Top 10" while other Widgets show all results).

The example below shows a page where a Widget Filter is applied only to the Net Sales by Subcategory chart, limiting it to three subcategories. The KPIs and Net Sales by Region chart are unaffected and show all data. Clicking the subcategory chart shows the active Widget Filter card in the Filters Panel.

#### Widget Filters

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "kpi-net-sales": {
          type: "value",
          dataMapping: { value: [{ id: "net_sales" }] },
          format: { caption: { enabled: true, text: "Net Sales" } },
        },
        "kpi-order-count": {
          type: "value",
          dataMapping: { value: [{ id: "order_count" }] },
          format: { caption: { enabled: true, text: "Order Count" } },
        },
        "kpi-aov": {
          type: "value",
          dataMapping: { value: [{ id: "average_order_value" }] },
          format: { caption: { enabled: true, text: "Avg Order Value" } },
        },
        "net-sales-by-region": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: { enabled: true, text: "Net Sales by Region - All Data" },
          },
        },
        "net-sales-by-subcategory": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Net Sales by Subcategory - Widget Filter Applied",
            },
          },
        },
      },
      widgetLayout: {
        "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
        "net-sales-by-region": { xTrack: 0, yTrack: 6, xSpan: 24, ySpan: 18 },
        "net-sales-by-subcategory": {
          xTrack: 0,
          yTrack: 24,
          xSpan: 24,
          ySpan: 18,
        },
      },
      filter: {
        widget: {
          "net-sales-by-subcategory": [
            {
              field: { id: "products.subcategory" },
              view: { expanded: true },
              model: {
                operator: "isIn",
                value: [
                  "Binders & Presentation",
                  "Desk Accessories",
                  "Paper & Notebooks",
                ],
              },
            },
          ],
        },
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["filters"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Widget Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/widget-filters/typescript/)

Page Filters and Widget Filters share the same filter types, described below. The available types depend on the field and [Widget](https://www.ag-grid.com/studio/archive/3.0.0/javascript/widgets/).

## Selection Filter

Selection Filter should be used when picking one or more values from a list, which is particularly useful for filtering categorical fields where a value list is the most direct way to specify the condition. Selection Filter is available for both Page Filters and Widget Filters.

## Simple Filter

Simple Filter should be used when expressing a condition using operators (for example, equals, does not equal, contains, or numeric comparisons). Some filter UIs also support combining conditions with AND/OR. Simple Filter is available for both Page Filters and Widget Filters.

## Rank Filter

Rank Filter should be used to restrict a Widget to the Top N and/or Bottom N categories based on a numeric result. Rank Filter is only available as a Widget Filter, and only when the Widget produces a numeric output per category, which includes any numeric field - whether used as a group-by or with a numeric [Aggregation](https://www.ag-grid.com/studio/archive/3.0.0/javascript/using-data/#aggregation) (for example, Count, Sum, Average, Minimum, Maximum). Only one Rank Filter can be active per Widget.

When Rank Filter is enabled, separate Top and Bottom values can be entered, where N is an integer.

The field used for ranking must be present in the Widget's [Data Mapping](https://www.ag-grid.com/studio/archive/3.0.0/javascript/building-widgets/#widget-setup). The ranking result is determined by how that field is used in the Widget - for example, ranking by Line Net with an Average aggregation ranks categories by their average Line Net value; ranking by a numeric group-by field ranks categories by the field's value directly.

The example below shows two bar charts using Rank Filters: the top chart shows the Top 5 subcategories by Average Line Net, sorted descending; the bottom chart shows the Bottom 5 subcategories by Net Sales, sorted ascending. The Filters Panel shows the active Rank Filter cards on each widget.

#### Rank Filter

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      layout: {},
      widgets: {
        "top-5": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "line_net", aggregation: "sum" }],
          },
          sort: [{ field: { id: "net_sales" }, direction: "desc" }],
          format: {
            title: {
              enabled: true,
              text: "Top 5 Subcategories by Line Net (avg)",
            },
          },
        },
        "bottom-5": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "net_sales" }],
          },
          sort: [{ field: { id: "net_sales" }, direction: "asc" }],
          format: {
            title: {
              enabled: true,
              text: "Bottom 5 Subcategories by Net Sales",
            },
          },
        },
      },
      widgetLayout: {
        "top-5": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
        "bottom-5": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 20 },
      },
      filter: {
        widget: {
          "top-5": [
            {
              field: { id: "line_net" },
              view: { expanded: true },
              model: {
                operator: "rank",
                value: [5, null],
              },
            },
          ],
          "bottom-5": [
            {
              field: { id: "net_sales" },
              view: { expanded: true },
              model: {
                operator: "rank",
                value: [null, 5],
              },
            },
          ],
        },
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["filters"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Rank Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/rank-filter/typescript/)

Rank Filter respects all other active Filters, and ranking is applied after existing Filters. If N exceeds the number of available categories, all available results are shown.

If the Widget changes so the category no longer produces a numeric output, the Rank Filter is cleared and a non-blocking message explains why it was removed.

## Cross-Filtering

Cross-filtering is driven by interacting with a Widget. When values are selected in a Widget, the selection becomes a filter condition that can affect other Widgets on the page. When cross-filtering is active, an additional Cross Filters section appears between Page Filters and Widget Filters.

Cross-filtering is configured per widget and is on by default. Settings can be changed in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#edit-panel). Cross-filtering has three modes:

- **Cross Highlight** - highlights proportional selection in the visualisation (pie, doughnut, bar, and column).
- **Cross Filter** - redraws data under the cross-filter condition.
- **None** - disables cross-filtering.

The example below shows a page with mixed cross-filter settings. The KPI Widgets have cross-filtering disabled - they display totals that reflect all data and do not respond to cross-filter changes. The bar, column, and pie charts use Cross Highlight mode, so a selection shows a proportional highlight without redrawing the data. The line chart uses Cross Filter mode, so it redraws under the cross-filter condition. UK is pre-selected in Net Sales by Region and Mid-Market in Net Sales by Segment to show the Filters Panel and highlight effects on load.

#### Cross-Filtering

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "kpi-net-sales": {
          type: "value",
          dataMapping: { value: [{ id: "net_sales" }] },
          format: {
            caption: { enabled: true, text: "Net Sales" },
            crossFilter: "none",
          },
        },
        "kpi-order-count": {
          type: "value",
          dataMapping: { value: [{ id: "order_count" }] },
          format: {
            caption: { enabled: true, text: "Order Count" },
            crossFilter: "none",
          },
        },
        "kpi-aov": {
          type: "value",
          dataMapping: { value: [{ id: "average_order_value" }] },
          format: {
            caption: { enabled: true, text: "Avg Order Value" },
            crossFilter: "none",
          },
        },
        "net-sales-by-region": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "stores.region" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: { title: { enabled: true, text: "Net Sales by Region" } },
        },
        "net-sales-by-subcategory": {
          type: "column-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "products.subcategory" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: { enabled: true, text: "Net Sales by Subcategory" },
          },
        },
        "net-sales-over-time": {
          type: "line-chart",
          dataMapping: {
            categoryKey: [{ id: "orders.order_month" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: { title: { enabled: true, text: "Net Sales over Time" } },
        },
        "net-sales-by-category": {
          type: "pie-chart",
          dataMapping: {
            categoryKey: [{ id: "customers.segment" }],
            valueKey: [{ id: "net_sales" }],
          },
          format: { title: { enabled: true, text: "Net Sales by Segment" } },
        },
      },
      widgetLayout: {
        "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
        "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
        "net-sales-over-time": { xTrack: 0, yTrack: 6, xSpan: 24, ySpan: 18 },
        "net-sales-by-subcategory": {
          xTrack: 0,
          yTrack: 24,
          xSpan: 24,
          ySpan: 18,
        },
        "net-sales-by-category": {
          xTrack: 0,
          yTrack: 42,
          xSpan: 12,
          ySpan: 18,
        },
        "net-sales-by-region": { xTrack: 12, yTrack: 42, xSpan: 12, ySpan: 18 },
      },
      crossFilter: {
        values: {
          "net-sales-by-region": [
            {
              type: "value",
              field: { id: "stores.region" },
              values: ["UK"],
            },
          ],
          "net-sales-by-category": [
            {
              type: "value",
              field: { id: "customers.segment" },
              values: ["Mid-Market"],
            },
          ],
        },
      },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["filters"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Cross-Filtering](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/cross-filtering/typescript/)

When cross-filtering applies a condition, a read-only, collapsed filter card is shown in the Cross Filters section of the Filters Panel indicating the applied condition. Cross Filters cards can be clicked to put the origin Widget into focus, and the condition can be removed using the 'x' action on the card.

Cross-filtering is designed to be quick and reversible. Clicking the same selection again clears the condition, including when using `^ Ctrl` for multi-select. If no cross-filtering is applied, the Cross Filters section is hidden.

## Filter Widgets

Filter Widgets are on-canvas filter controls that allow report consumers to filter the page using visible controls, without opening the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/javascript/filters/#filters-panel).

AG Studio supports three types of Filter Widgets:

| Type | Description | Input Requirements |
| --- | --- | --- |
| **List** | A dropdown or list that allows selecting one or more values from available options. | Any categorical or value field, such as product names, regions, or status |
| **Button** | Button-based controls that display distinct values as individual buttons for quick selection. | Any categorical or value field, such as product names, regions, or status |
| **Date** | A date picker that allows selecting a date, date range, or predefined date ranges. | Date or DateTime fields |

Filter Widgets do not update in response to Page and Widget Filters or cross-filter conditions. In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/javascript/user-interface/#modes), clicking a Filter Widget puts it in focus and exposes its options in the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/javascript/filters/#filters-panel), where the available options can be customised using a Widget Filter.

When a Filter Widget applies a condition, a read-only card appears in the Page Filters section of the Filters Panel, and the condition can be cleared using the 'x' action, which is equivalent to clearing the Filter Widget selection directly.

The example below uses List Filter Widgets to filter a nuclear dataset. Click values in any filter list to apply a condition and watch the corresponding card appear in the Filters Panel. Switch to Edit mode, click a Filter Widget to put it in focus, and update its options in the Filters Panel to see the available selections being customised.

#### Filter Widgets

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getNuclearDataSource } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "segre-chart",
      widgets: {
        "report-title": {
          type: "text",
          dataMapping: {},
          format: {
            style: {
              text: "Nuclear Wallet Cards - Segrè Chart Visualization",
              typography: { fontWeight: "normal" },
            },
          },
        },
        "element-family-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Element Family" }],
          },
        },
        "stability-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Stability" }],
          },
        },
        "occurrence-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Occurrence" }],
          },
        },
        "decay-mode-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Decay Mode" }],
          },
        },
        "nuclides-chart": {
          type: "scatter-chart",
          dataMapping: {
            categoryKey: [
              { id: "nuclear-data.Neutrons (N)", aggregation: "first" },
            ],
            valueKey: [
              { id: "nuclear-data.Atomic Number (Z)", aggregation: "first" },
            ],
            groupByKey: [{ id: "nuclear-data.Element + Atomic Mass (A)" }],
            tooltipKey: [
              { id: "nuclear-data.Element", aggregation: "first" },
              { id: "nuclear-data.Atomic Mass (A)", aggregation: "first" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Chart of Nuclides",
            },
            subtitle: {
              enabled: true,
              text: "A Segrè chart showing isotopes by neutron count and atomic number.",
            },
          },
        },
        "element-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "nuclear-data.Element + Atomic Mass (A)" },
              { id: "nuclear-data.Element" },
              { id: "nuclear-data.Atomic Number (Z)" },
              { id: "nuclear-data.Atomic Mass (A)" },
              { id: "nuclear-data.Neutrons (N)" },
              { id: "nuclear-data.Half-Life" },
              { id: "nuclear-data.Half-Life (Unit)" },
              { id: "nuclear-data.Spin-Parity" },
              { id: "nuclear-data.Decay Modes" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Nuclear Properties",
            },
            style: {
              theme: { rowHeight: 28 },
            },
          },
        },
      },
      widgetLayout: {
        "report-title": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 4 },
        "element-family-filter": { xTrack: 0, yTrack: 4, xSpan: 6, ySpan: 12 },
        "stability-filter": { xTrack: 0, yTrack: 16, xSpan: 6, ySpan: 9 },
        "occurrence-filter": { xTrack: 0, yTrack: 25, xSpan: 6, ySpan: 6 },
        "decay-mode-filter": { xTrack: 0, yTrack: 31, xSpan: 6, ySpan: 9 },
        "nuclides-chart": { xTrack: 6, yTrack: 4, xSpan: 18, ySpan: 36 },
        "element-grid": { xTrack: 0, yTrack: 40, xSpan: 24, ySpan: 14 },
      },
      filter: {
        page: [],
      },
    },
  ],
  selectedPageId: "segre-chart",
};

let studioApi: AgStudioApi;

async function getStudioProperties(): Promise<AgStudioProperties> {
  const nuclearSource = await getNuclearDataSource();

  return {
    mode: "view",
    initialState,
    data: {
      sources: [nuclearSource],
      relationships: [],
    },
  };
}

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
const studioProperties = await getStudioProperties();
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Filter Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/filter-widgets/typescript/)


---
product: "AG Studio"
title: "Filters"
description: "Filters change the data shown on a Page or Widget."
framework: angular
version: "3.0.0"
related:
    - title: "Data Setup"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/data-setup/"
    - title: "Using Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/using-data/"
    - title: "Calculations"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/creating-calculations/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Filters

Filters change the data shown on a Page or Widget.

Filters can be applied in a few different ways. Page and Widget Filters can be added in the Filters Panel, Filter Widgets can be used on the layout, or cross-filtering can be applied by interacting with a Widget. When Filter Widgets or cross-filtering apply a condition, it appears in the Filters Panel as a read-only card.

There are four types of filters in AG Studio:

- **Page Filters** - apply to all Widgets on the page and are managed in the Filters Panel,
- **Widget Filters** - apply only to a specific Widget and are managed in the Filters Panel,
- **Cross-filtering** - filters driven by interacting with a Widget,
- **Filter Widgets** - on-canvas filter controls that apply a page filter and appear as a read-only card in the Page Filters section.

## Filters Panel

The Filters Panel provides a centralised space for managing all filter types. Filters are presented as cards, organised by type.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#modes), filters can be added, removed, and reordered by dragging filter cards within a section. In [View Mode](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#modes), the configuration of Page Filters and Widget Filters can be changed, but by default filters cannot be added or removed - your developer can enable this. Read-only cards, such as those for Filter Widgets and cross-filtering conditions, can always be removed from the Filters Panel regardless of mode.

Filter Widgets and cross-filtering conditions appear as read-only, collapsed cards, so the report user can see at a glance what is affecting the data display. Clicking a Widget Filter or Cross Filter card puts the origin Widget into focus.

### Applying Filter Changes

By default, a change to a filter card takes effect straight away and the page updates as you type.

Your developer can instead configure the Filters Panel so that changes are held until you confirm them. In that case each expanded filter card shows **Apply** and **Cancel** buttons at the bottom. Nothing on the page changes until you press Apply, and Cancel returns the card to the values that were last applied. This suits reports whose data is fetched from a server, where every keystroke would otherwise start a new query.

A card holding changes you have not applied yet is marked with an edit indicator in its header, so you can still see which filters are pending while the cards are collapsed. A collapsed card always describes the filter that is actually applied, not the change you are part-way through making.

Two behaviours are worth knowing about. A filter that is only partly filled in - the start of a range with no end, for example - does not count as a filter at all, so Apply stays greyed out until the condition is complete. And clearing one end of a range that has already been applied removes the filter, because the remaining condition is incomplete.

The example below is in View Mode and opens with a region Page Filter and a date Page Filter already applied, both cards expanded so the button row is visible. The report is configured with `applyOnChange: false`, so changing a card's values holds the edit rather than applying it - add or remove a region and the Widgets stay as they are until Apply is pressed. Cancel restores the values that were last applied.

#### Staged Filter Changes

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Staged Filter Changes](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/staged-filters/angular/)

## Page Filters

Page Filters apply to all Widgets on the current page. Page Filters should be used when a consistent slice of data is required across the whole page (for example, a single region or date range).

The example below shows a page with a date Page Filter applied. The filter affects all Widgets on the page - the KPIs and both bar charts (Net Sales by Region and Net Sales by Subcategory) all reflect the same filtered data.

#### Page Filters

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Page Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/page-filters/angular/)

## Widget Filters

Widget Filters apply only to one Widget. Widget Filters should be used when a Widget needs a different scope from the rest of the page (for example, one chart showing "Top 10" while other Widgets show all results).

The example below shows a page where a Widget Filter is applied only to the Net Sales by Subcategory chart, limiting it to three subcategories. The KPIs and Net Sales by Region chart are unaffected and show all data. Clicking the subcategory chart shows the active Widget Filter card in the Filters Panel.

#### Widget Filters

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Widget Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/widget-filters/angular/)

Page Filters and Widget Filters share the same filter types, described below. The available types depend on the field and [Widget](https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/).

## Selection Filter

Selection Filter should be used when picking one or more values from a list, which is particularly useful for filtering categorical fields where a value list is the most direct way to specify the condition. Selection Filter is available for both Page Filters and Widget Filters.

## Simple Filter

Simple Filter should be used when expressing a condition using operators (for example, equals, does not equal, contains, or numeric comparisons). Some filter UIs also support combining conditions with AND/OR. Simple Filter is available for both Page Filters and Widget Filters.

## Rank Filter

Rank Filter should be used to restrict a Widget to the Top N and/or Bottom N categories based on a numeric result. Rank Filter is only available as a Widget Filter, and only when the Widget produces a numeric output per category, which includes any numeric field - whether used as a group-by or with a numeric [Aggregation](https://www.ag-grid.com/studio/archive/3.0.0/angular/using-data/#aggregation) (for example, Count, Sum, Average, Minimum, Maximum). Only one Rank Filter can be active per Widget.

When Rank Filter is enabled, separate Top and Bottom values can be entered, where N is an integer.

The field used for ranking must be present in the Widget's [Data Mapping](https://www.ag-grid.com/studio/archive/3.0.0/angular/building-widgets/#widget-setup). The ranking result is determined by how that field is used in the Widget - for example, ranking by Line Net with an Average aggregation ranks categories by their average Line Net value; ranking by a numeric group-by field ranks categories by the field's value directly.

The example below shows two bar charts using Rank Filters: the top chart shows the Top 5 subcategories by Average Line Net, sorted descending; the bottom chart shows the Bottom 5 subcategories by Net Sales, sorted ascending. The Filters Panel shows the active Rank Filter cards on each widget.

#### Rank Filter

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Rank Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/rank-filter/angular/)

Rank Filter respects all other active Filters, and ranking is applied after existing Filters. If N exceeds the number of available categories, all available results are shown.

If the Widget changes so the category no longer produces a numeric output, the Rank Filter is cleared and a non-blocking message explains why it was removed.

## Cross-Filtering

Cross-filtering is driven by interacting with a Widget. When values are selected in a Widget, the selection becomes a filter condition that can affect other Widgets on the page. When cross-filtering is active, an additional Cross Filters section appears between Page Filters and Widget Filters.

Cross-filtering is configured per widget and is on by default. Settings can be changed in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#edit-panel). Cross-filtering has three modes:

- **Cross Highlight** - highlights proportional selection in the visualisation (pie, doughnut, bar, and column).
- **Cross Filter** - redraws data under the cross-filter condition.
- **None** - disables cross-filtering.

The example below shows a page with mixed cross-filter settings. The KPI Widgets have cross-filtering disabled - they display totals that reflect all data and do not respond to cross-filter changes. The bar, column, and pie charts use Cross Highlight mode, so a selection shows a proportional highlight without redrawing the data. The line chart uses Cross Filter mode, so it redraws under the cross-filter condition. UK is pre-selected in Net Sales by Region and Mid-Market in Net Sales by Segment to show the Filters Panel and highlight effects on load.

#### Cross-Filtering

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Cross-Filtering](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/cross-filtering/angular/)

When cross-filtering applies a condition, a read-only, collapsed filter card is shown in the Cross Filters section of the Filters Panel indicating the applied condition. Cross Filters cards can be clicked to put the origin Widget into focus, and the condition can be removed using the 'x' action on the card.

Cross-filtering is designed to be quick and reversible. Clicking the same selection again clears the condition, including when using `^ Ctrl` for multi-select. If no cross-filtering is applied, the Cross Filters section is hidden.

## Filter Widgets

Filter Widgets are on-canvas filter controls that allow report consumers to filter the page using visible controls, without opening the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/angular/filters/#filters-panel).

AG Studio supports three types of Filter Widgets:

| Type | Description | Input Requirements |
| --- | --- | --- |
| **List** | A dropdown or list that allows selecting one or more values from available options. | Any categorical or value field, such as product names, regions, or status |
| **Button** | Button-based controls that display distinct values as individual buttons for quick selection. | Any categorical or value field, such as product names, regions, or status |
| **Date** | A date picker that allows selecting a date, date range, or predefined date ranges. | Date or DateTime fields |

Filter Widgets do not update in response to Page and Widget Filters or cross-filter conditions. In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/angular/user-interface/#modes), clicking a Filter Widget puts it in focus and exposes its options in the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/angular/filters/#filters-panel), where the available options can be customised using a Widget Filter.

When a Filter Widget applies a condition, a read-only card appears in the Page Filters section of the Filters Panel, and the condition can be cleared using the 'x' action, which is equivalent to clearing the Filter Widget selection directly.

The example below uses List Filter Widgets to filter a nuclear dataset. Click values in any filter list to apply a condition and watch the corresponding card appear in the Filters Panel. Switch to Edit mode, click a Filter Widget to put it in focus, and update its options in the Filters Panel to see the available selections being customised.

#### Filter Widgets

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getNuclearDataSource } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "segre-chart",
      widgets: {
        "report-title": {
          type: "text",
          dataMapping: {},
          format: {
            style: {
              text: "Nuclear Wallet Cards - Segrè Chart Visualization",
              typography: { fontWeight: "normal" },
            },
          },
        },
        "element-family-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Element Family" }],
          },
        },
        "stability-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Stability" }],
          },
        },
        "occurrence-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Occurrence" }],
          },
        },
        "decay-mode-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Decay Mode" }],
          },
        },
        "nuclides-chart": {
          type: "scatter-chart",
          dataMapping: {
            categoryKey: [
              { id: "nuclear-data.Neutrons (N)", aggregation: "first" },
            ],
            valueKey: [
              { id: "nuclear-data.Atomic Number (Z)", aggregation: "first" },
            ],
            groupByKey: [{ id: "nuclear-data.Element + Atomic Mass (A)" }],
            tooltipKey: [
              { id: "nuclear-data.Element", aggregation: "first" },
              { id: "nuclear-data.Atomic Mass (A)", aggregation: "first" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Chart of Nuclides",
            },
            subtitle: {
              enabled: true,
              text: "A Segrè chart showing isotopes by neutron count and atomic number.",
            },
          },
        },
        "element-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "nuclear-data.Element + Atomic Mass (A)" },
              { id: "nuclear-data.Element" },
              { id: "nuclear-data.Atomic Number (Z)" },
              { id: "nuclear-data.Atomic Mass (A)" },
              { id: "nuclear-data.Neutrons (N)" },
              { id: "nuclear-data.Half-Life" },
              { id: "nuclear-data.Half-Life (Unit)" },
              { id: "nuclear-data.Spin-Parity" },
              { id: "nuclear-data.Decay Modes" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Nuclear Properties",
            },
            style: {
              theme: { rowHeight: 28 },
            },
          },
        },
      },
      widgetLayout: {
        "report-title": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 4 },
        "element-family-filter": { xTrack: 0, yTrack: 4, xSpan: 6, ySpan: 12 },
        "stability-filter": { xTrack: 0, yTrack: 16, xSpan: 6, ySpan: 9 },
        "occurrence-filter": { xTrack: 0, yTrack: 25, xSpan: 6, ySpan: 6 },
        "decay-mode-filter": { xTrack: 0, yTrack: 31, xSpan: 6, ySpan: 9 },
        "nuclides-chart": { xTrack: 6, yTrack: 4, xSpan: 18, ySpan: 36 },
        "element-grid": { xTrack: 0, yTrack: 40, xSpan: 24, ySpan: 14 },
      },
      filter: {
        page: [],
      },
    },
  ],
  selectedPageId: "segre-chart",
};

let studioApi: AgStudioApi;

async function getStudioProperties(): Promise<AgStudioProperties> {
  const nuclearSource = await getNuclearDataSource();

  return {
    mode: "view",
    initialState,
    data: {
      sources: [nuclearSource],
      relationships: [],
    },
  };
}

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
const studioProperties = await getStudioProperties();
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Filter Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/filter-widgets/typescript/)


---
product: "AG Studio"
title: "Filters"
description: "Filters change the data shown on a Page or Widget."
framework: vue
version: "3.0.0"
related:
    - title: "Data Setup"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/data-setup/"
    - title: "Using Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/using-data/"
    - title: "Calculations"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/creating-calculations/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Filters

Filters change the data shown on a Page or Widget.

Filters can be applied in a few different ways. Page and Widget Filters can be added in the Filters Panel, Filter Widgets can be used on the layout, or cross-filtering can be applied by interacting with a Widget. When Filter Widgets or cross-filtering apply a condition, it appears in the Filters Panel as a read-only card.

There are four types of filters in AG Studio:

- **Page Filters** - apply to all Widgets on the page and are managed in the Filters Panel,
- **Widget Filters** - apply only to a specific Widget and are managed in the Filters Panel,
- **Cross-filtering** - filters driven by interacting with a Widget,
- **Filter Widgets** - on-canvas filter controls that apply a page filter and appear as a read-only card in the Page Filters section.

## Filters Panel

The Filters Panel provides a centralised space for managing all filter types. Filters are presented as cards, organised by type.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#modes), filters can be added, removed, and reordered by dragging filter cards within a section. In [View Mode](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#modes), the configuration of Page Filters and Widget Filters can be changed, but by default filters cannot be added or removed - your developer can enable this. Read-only cards, such as those for Filter Widgets and cross-filtering conditions, can always be removed from the Filters Panel regardless of mode.

Filter Widgets and cross-filtering conditions appear as read-only, collapsed cards, so the report user can see at a glance what is affecting the data display. Clicking a Widget Filter or Cross Filter card puts the origin Widget into focus.

### Applying Filter Changes

By default, a change to a filter card takes effect straight away and the page updates as you type.

Your developer can instead configure the Filters Panel so that changes are held until you confirm them. In that case each expanded filter card shows **Apply** and **Cancel** buttons at the bottom. Nothing on the page changes until you press Apply, and Cancel returns the card to the values that were last applied. This suits reports whose data is fetched from a server, where every keystroke would otherwise start a new query.

A card holding changes you have not applied yet is marked with an edit indicator in its header, so you can still see which filters are pending while the cards are collapsed. A collapsed card always describes the filter that is actually applied, not the change you are part-way through making.

Two behaviours are worth knowing about. A filter that is only partly filled in - the start of a range with no end, for example - does not count as a filter at all, so Apply stays greyed out until the condition is complete. And clearing one end of a range that has already been applied removes the filter, because the remaining condition is incomplete.

The example below is in View Mode and opens with a region Page Filter and a date Page Filter already applied, both cards expanded so the button row is visible. The report is configured with `applyOnChange: false`, so changing a card's values holds the edit rather than applying it - add or remove a region and the Widgets stay as they are until Apply is pressed. Cancel restores the values that were last applied.

#### Staged Filter Changes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            // Both cards start expanded and already applied, so the Apply and Cancel buttons
            // are visible on load without the reader having to add a filter first.
            page: [
              {
                field: { id: "stores.region" },
                view: { expanded: true, viewTypeId: "selection" },
                model: {
                  operator: "isIn",
                  value: ["DACH", "UK"],
                },
              },
              {
                field: { id: "orders.order_datetime" },
                view: { expanded: true },
                model: {
                  operator: "greaterThan",
                  value: "2024-12-01",
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("view");
    const panels = ref<AgPanelConfig>({
      // An options-only config leaves each mode's default panels in place, so view mode still
      // shows the filters panel on the right.
      options: {
        filters: { applyOnChange: false },
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Staged Filter Changes](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/staged-filters/vue3/)

## Page Filters

Page Filters apply to all Widgets on the current page. Page Filters should be used when a consistent slice of data is required across the whole page (for example, a single region or date range).

The example below shows a page with a date Page Filter applied. The filter affects all Widgets on the page - the KPIs and both bar charts (Net Sales by Region and Net Sales by Subcategory) all reflect the same filtered data.

#### Page Filters

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            page: [
              {
                field: { id: "orders.order_datetime" },
                view: { expanded: true },
                model: {
                  operator: "greaterThan",
                  value: "2024-12-01",
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["filters"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Page Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/page-filters/vue3/)

## Widget Filters

Widget Filters apply only to one Widget. Widget Filters should be used when a Widget needs a different scope from the rest of the page (for example, one chart showing "Top 10" while other Widgets show all results).

The example below shows a page where a Widget Filter is applied only to the Net Sales by Subcategory chart, limiting it to three subcategories. The KPIs and Net Sales by Region chart are unaffected and show all data. Clicking the subcategory chart shows the active Widget Filter card in the Filters Panel.

#### Widget Filters

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region - All Data",
                },
              },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Subcategory - Widget Filter Applied",
                },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            widget: {
              "net-sales-by-subcategory": [
                {
                  field: { id: "products.subcategory" },
                  view: { expanded: true },
                  model: {
                    operator: "isIn",
                    value: [
                      "Binders & Presentation",
                      "Desk Accessories",
                      "Paper & Notebooks",
                    ],
                  },
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["filters"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Widget Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/widget-filters/vue3/)

Page Filters and Widget Filters share the same filter types, described below. The available types depend on the field and [Widget](https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/).

## Selection Filter

Selection Filter should be used when picking one or more values from a list, which is particularly useful for filtering categorical fields where a value list is the most direct way to specify the condition. Selection Filter is available for both Page Filters and Widget Filters.

## Simple Filter

Simple Filter should be used when expressing a condition using operators (for example, equals, does not equal, contains, or numeric comparisons). Some filter UIs also support combining conditions with AND/OR. Simple Filter is available for both Page Filters and Widget Filters.

## Rank Filter

Rank Filter should be used to restrict a Widget to the Top N and/or Bottom N categories based on a numeric result. Rank Filter is only available as a Widget Filter, and only when the Widget produces a numeric output per category, which includes any numeric field - whether used as a group-by or with a numeric [Aggregation](https://www.ag-grid.com/studio/archive/3.0.0/vue/using-data/#aggregation) (for example, Count, Sum, Average, Minimum, Maximum). Only one Rank Filter can be active per Widget.

When Rank Filter is enabled, separate Top and Bottom values can be entered, where N is an integer.

The field used for ranking must be present in the Widget's [Data Mapping](https://www.ag-grid.com/studio/archive/3.0.0/vue/building-widgets/#widget-setup). The ranking result is determined by how that field is used in the Widget - for example, ranking by Line Net with an Average aggregation ranks categories by their average Line Net value; ranking by a numeric group-by field ranks categories by the field's value directly.

The example below shows two bar charts using Rank Filters: the top chart shows the Top 5 subcategories by Average Line Net, sorted descending; the bottom chart shows the Bottom 5 subcategories by Net Sales, sorted ascending. The Filters Panel shows the active Rank Filter cards on each widget.

#### Rank Filter

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          layout: {},
          widgets: {
            "top-5": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "line_net", aggregation: "sum" }],
              },
              sort: [{ field: { id: "net_sales" }, direction: "desc" }],
              format: {
                title: {
                  enabled: true,
                  text: "Top 5 Subcategories by Line Net (avg)",
                },
              },
            },
            "bottom-5": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              sort: [{ field: { id: "net_sales" }, direction: "asc" }],
              format: {
                title: {
                  enabled: true,
                  text: "Bottom 5 Subcategories by Net Sales",
                },
              },
            },
          },
          widgetLayout: {
            "top-5": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "bottom-5": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 20 },
          },
          filter: {
            widget: {
              "top-5": [
                {
                  field: { id: "line_net" },
                  view: { expanded: true },
                  model: {
                    operator: "rank",
                    value: [5, null],
                  },
                },
              ],
              "bottom-5": [
                {
                  field: { id: "net_sales" },
                  view: { expanded: true },
                  model: {
                    operator: "rank",
                    value: [null, 5],
                  },
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["filters"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Rank Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/rank-filter/vue3/)

Rank Filter respects all other active Filters, and ranking is applied after existing Filters. If N exceeds the number of available categories, all available results are shown.

If the Widget changes so the category no longer produces a numeric output, the Rank Filter is cleared and a non-blocking message explains why it was removed.

## Cross-Filtering

Cross-filtering is driven by interacting with a Widget. When values are selected in a Widget, the selection becomes a filter condition that can affect other Widgets on the page. When cross-filtering is active, an additional Cross Filters section appears between Page Filters and Widget Filters.

Cross-filtering is configured per widget and is on by default. Settings can be changed in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#edit-panel). Cross-filtering has three modes:

- **Cross Highlight** - highlights proportional selection in the visualisation (pie, doughnut, bar, and column).
- **Cross Filter** - redraws data under the cross-filter condition.
- **None** - disables cross-filtering.

The example below shows a page with mixed cross-filter settings. The KPI Widgets have cross-filtering disabled - they display totals that reflect all data and do not respond to cross-filter changes. The bar, column, and pie charts use Cross Highlight mode, so a selection shows a proportional highlight without redrawing the data. The line chart uses Cross Filter mode, so it redraws under the cross-filter condition. UK is pre-selected in Net Sales by Region and Mid-Market in Net Sales by Segment to show the Filters Panel and highlight effects on load.

#### Cross-Filtering

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: {
                caption: { enabled: true, text: "Net Sales" },
                crossFilter: "none",
              },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: {
                caption: { enabled: true, text: "Order Count" },
                crossFilter: "none",
              },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: {
                caption: { enabled: true, text: "Avg Order Value" },
                crossFilter: "none",
              },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
            "net-sales-over-time": {
              type: "line-chart",
              dataMapping: {
                categoryKey: [{ id: "orders.order_month" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales over Time" } },
            },
            "net-sales-by-category": {
              type: "pie-chart",
              dataMapping: {
                categoryKey: [{ id: "customers.segment" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Segment" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-over-time": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-category": {
              xTrack: 0,
              yTrack: 42,
              xSpan: 12,
              ySpan: 18,
            },
            "net-sales-by-region": {
              xTrack: 12,
              yTrack: 42,
              xSpan: 12,
              ySpan: 18,
            },
          },
          crossFilter: {
            values: {
              "net-sales-by-region": [
                {
                  type: "value",
                  field: { id: "stores.region" },
                  values: ["UK"],
                },
              ],
              "net-sales-by-category": [
                {
                  type: "value",
                  field: { id: "customers.segment" },
                  values: ["Mid-Market"],
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["filters"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cross-Filtering](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/cross-filtering/vue3/)

When cross-filtering applies a condition, a read-only, collapsed filter card is shown in the Cross Filters section of the Filters Panel indicating the applied condition. Cross Filters cards can be clicked to put the origin Widget into focus, and the condition can be removed using the 'x' action on the card.

Cross-filtering is designed to be quick and reversible. Clicking the same selection again clears the condition, including when using `^ Ctrl` for multi-select. If no cross-filtering is applied, the Cross Filters section is hidden.

## Filter Widgets

Filter Widgets are on-canvas filter controls that allow report consumers to filter the page using visible controls, without opening the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/vue/filters/#filters-panel).

AG Studio supports three types of Filter Widgets:

| Type | Description | Input Requirements |
| --- | --- | --- |
| **List** | A dropdown or list that allows selecting one or more values from available options. | Any categorical or value field, such as product names, regions, or status |
| **Button** | Button-based controls that display distinct values as individual buttons for quick selection. | Any categorical or value field, such as product names, regions, or status |
| **Date** | A date picker that allows selecting a date, date range, or predefined date ranges. | Date or DateTime fields |

Filter Widgets do not update in response to Page and Widget Filters or cross-filter conditions. In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/vue/user-interface/#modes), clicking a Filter Widget puts it in focus and exposes its options in the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/vue/filters/#filters-panel), where the available options can be customised using a Widget Filter.

When a Filter Widget applies a condition, a read-only card appears in the Page Filters section of the Filters Panel, and the condition can be cleared using the 'x' action, which is equivalent to clearing the Filter Widget selection directly.

The example below uses List Filter Widgets to filter a nuclear dataset. Click values in any filter list to apply a condition and watch the corresponding card appear in the Filters Panel. Switch to Edit mode, click a Filter Widget to put it in focus, and update its options in the Filters Panel to see the available selections being customised.

#### Filter Widgets

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getNuclearDataSource } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "segre-chart",
      widgets: {
        "report-title": {
          type: "text",
          dataMapping: {},
          format: {
            style: {
              text: "Nuclear Wallet Cards - Segrè Chart Visualization",
              typography: { fontWeight: "normal" },
            },
          },
        },
        "element-family-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Element Family" }],
          },
        },
        "stability-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Stability" }],
          },
        },
        "occurrence-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Occurrence" }],
          },
        },
        "decay-mode-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Decay Mode" }],
          },
        },
        "nuclides-chart": {
          type: "scatter-chart",
          dataMapping: {
            categoryKey: [
              { id: "nuclear-data.Neutrons (N)", aggregation: "first" },
            ],
            valueKey: [
              { id: "nuclear-data.Atomic Number (Z)", aggregation: "first" },
            ],
            groupByKey: [{ id: "nuclear-data.Element + Atomic Mass (A)" }],
            tooltipKey: [
              { id: "nuclear-data.Element", aggregation: "first" },
              { id: "nuclear-data.Atomic Mass (A)", aggregation: "first" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Chart of Nuclides",
            },
            subtitle: {
              enabled: true,
              text: "A Segrè chart showing isotopes by neutron count and atomic number.",
            },
          },
        },
        "element-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "nuclear-data.Element + Atomic Mass (A)" },
              { id: "nuclear-data.Element" },
              { id: "nuclear-data.Atomic Number (Z)" },
              { id: "nuclear-data.Atomic Mass (A)" },
              { id: "nuclear-data.Neutrons (N)" },
              { id: "nuclear-data.Half-Life" },
              { id: "nuclear-data.Half-Life (Unit)" },
              { id: "nuclear-data.Spin-Parity" },
              { id: "nuclear-data.Decay Modes" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Nuclear Properties",
            },
            style: {
              theme: { rowHeight: 28 },
            },
          },
        },
      },
      widgetLayout: {
        "report-title": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 4 },
        "element-family-filter": { xTrack: 0, yTrack: 4, xSpan: 6, ySpan: 12 },
        "stability-filter": { xTrack: 0, yTrack: 16, xSpan: 6, ySpan: 9 },
        "occurrence-filter": { xTrack: 0, yTrack: 25, xSpan: 6, ySpan: 6 },
        "decay-mode-filter": { xTrack: 0, yTrack: 31, xSpan: 6, ySpan: 9 },
        "nuclides-chart": { xTrack: 6, yTrack: 4, xSpan: 18, ySpan: 36 },
        "element-grid": { xTrack: 0, yTrack: 40, xSpan: 24, ySpan: 14 },
      },
      filter: {
        page: [],
      },
    },
  ],
  selectedPageId: "segre-chart",
};

let studioApi: AgStudioApi;

async function getStudioProperties(): Promise<AgStudioProperties> {
  const nuclearSource = await getNuclearDataSource();

  return {
    mode: "view",
    initialState,
    data: {
      sources: [nuclearSource],
      relationships: [],
    },
  };
}

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
const studioProperties = await getStudioProperties();
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Filter Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/filter-widgets/typescript/)


---
product: "AG Studio"
title: "Filters"
description: "Filters change the data shown on a Page or Widget."
framework: react
version: "3.0.0"
related:
    - title: "Data Setup"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/data-setup/"
    - title: "Using Data"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/using-data/"
    - title: "Calculations"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/creating-calculations/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Filters

Filters change the data shown on a Page or Widget.

Filters can be applied in a few different ways. Page and Widget Filters can be added in the Filters Panel, Filter Widgets can be used on the layout, or cross-filtering can be applied by interacting with a Widget. When Filter Widgets or cross-filtering apply a condition, it appears in the Filters Panel as a read-only card.

There are four types of filters in AG Studio:

- **Page Filters** - apply to all Widgets on the page and are managed in the Filters Panel,
- **Widget Filters** - apply only to a specific Widget and are managed in the Filters Panel,
- **Cross-filtering** - filters driven by interacting with a Widget,
- **Filter Widgets** - on-canvas filter controls that apply a page filter and appear as a read-only card in the Page Filters section.

## Filters Panel

The Filters Panel provides a centralised space for managing all filter types. Filters are presented as cards, organised by type.

In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#modes), filters can be added, removed, and reordered by dragging filter cards within a section. In [View Mode](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#modes), the configuration of Page Filters and Widget Filters can be changed, but by default filters cannot be added or removed - your developer can enable this. Read-only cards, such as those for Filter Widgets and cross-filtering conditions, can always be removed from the Filters Panel regardless of mode.

Filter Widgets and cross-filtering conditions appear as read-only, collapsed cards, so the report user can see at a glance what is affecting the data display. Clicking a Widget Filter or Cross Filter card puts the origin Widget into focus.

### Applying Filter Changes

By default, a change to a filter card takes effect straight away and the page updates as you type.

Your developer can instead configure the Filters Panel so that changes are held until you confirm them. In that case each expanded filter card shows **Apply** and **Cancel** buttons at the bottom. Nothing on the page changes until you press Apply, and Cancel returns the card to the values that were last applied. This suits reports whose data is fetched from a server, where every keystroke would otherwise start a new query.

A card holding changes you have not applied yet is marked with an edit indicator in its header, so you can still see which filters are pending while the cards are collapsed. A collapsed card always describes the filter that is actually applied, not the change you are part-way through making.

Two behaviours are worth knowing about. A filter that is only partly filled in - the start of a range with no end, for example - does not count as a filter at all, so Apply stays greyed out until the condition is complete. And clearing one end of a range that has already been applied removes the filter, because the remaining condition is incomplete.

The example below is in View Mode and opens with a region Page Filter and a date Page Filter already applied, both cards expanded so the button row is visible. The report is configured with `applyOnChange: false`, so changing a card's values holds the edit rather than applying it - add or remove a region and the Widgets stay as they are until Apply is pressed. Cancel restores the values that were last applied.

#### Staged Filter Changes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            // Both cards start expanded and already applied, so the Apply and Cancel buttons
            // are visible on load without the reader having to add a filter first.
            page: [
              {
                field: { id: "stores.region" },
                view: { expanded: true, viewTypeId: "selection" },
                model: {
                  operator: "isIn",
                  value: ["DACH", "UK"],
                },
              },
              {
                field: { id: "orders.order_datetime" },
                view: { expanded: true },
                model: {
                  operator: "greaterThan",
                  value: "2024-12-01",
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      // An options-only config leaves each mode's default panels in place, so view mode still
      // shows the filters panel on the right.
      options: {
        filters: { applyOnChange: false },
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"view"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Staged Filter Changes](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/staged-filters/reactFunctionalTs/)

## Page Filters

Page Filters apply to all Widgets on the current page. Page Filters should be used when a consistent slice of data is required across the whole page (for example, a single region or date range).

The example below shows a page with a date Page Filter applied. The filter affects all Widgets on the page - the KPIs and both bar charts (Net Sales by Region and Net Sales by Subcategory) all reflect the same filtered data.

#### Page Filters

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            page: [
              {
                field: { id: "orders.order_datetime" },
                view: { expanded: true },
                model: {
                  operator: "greaterThan",
                  value: "2024-12-01",
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["filters"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Page Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/page-filters/reactFunctionalTs/)

## Widget Filters

Widget Filters apply only to one Widget. Widget Filters should be used when a Widget needs a different scope from the rest of the page (for example, one chart showing "Top 10" while other Widgets show all results).

The example below shows a page where a Widget Filter is applied only to the Net Sales by Subcategory chart, limiting it to three subcategories. The KPIs and Net Sales by Region chart are unaffected and show all data. Clicking the subcategory chart shows the active Widget Filter card in the Filters Panel.

#### Widget Filters

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: { caption: { enabled: true, text: "Net Sales" } },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: { caption: { enabled: true, text: "Order Count" } },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: { caption: { enabled: true, text: "Avg Order Value" } },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region - All Data",
                },
              },
            },
            "net-sales-by-subcategory": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Subcategory - Widget Filter Applied",
                },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-by-region": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
          },
          filter: {
            widget: {
              "net-sales-by-subcategory": [
                {
                  field: { id: "products.subcategory" },
                  view: { expanded: true },
                  model: {
                    operator: "isIn",
                    value: [
                      "Binders & Presentation",
                      "Desk Accessories",
                      "Paper & Notebooks",
                    ],
                  },
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["filters"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Widget Filters](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/widget-filters/reactFunctionalTs/)

Page Filters and Widget Filters share the same filter types, described below. The available types depend on the field and [Widget](https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/).

## Selection Filter

Selection Filter should be used when picking one or more values from a list, which is particularly useful for filtering categorical fields where a value list is the most direct way to specify the condition. Selection Filter is available for both Page Filters and Widget Filters.

## Simple Filter

Simple Filter should be used when expressing a condition using operators (for example, equals, does not equal, contains, or numeric comparisons). Some filter UIs also support combining conditions with AND/OR. Simple Filter is available for both Page Filters and Widget Filters.

## Rank Filter

Rank Filter should be used to restrict a Widget to the Top N and/or Bottom N categories based on a numeric result. Rank Filter is only available as a Widget Filter, and only when the Widget produces a numeric output per category, which includes any numeric field - whether used as a group-by or with a numeric [Aggregation](https://www.ag-grid.com/studio/archive/3.0.0/react/using-data/#aggregation) (for example, Count, Sum, Average, Minimum, Maximum). Only one Rank Filter can be active per Widget.

When Rank Filter is enabled, separate Top and Bottom values can be entered, where N is an integer.

The field used for ranking must be present in the Widget's [Data Mapping](https://www.ag-grid.com/studio/archive/3.0.0/react/building-widgets/#widget-setup). The ranking result is determined by how that field is used in the Widget - for example, ranking by Line Net with an Average aggregation ranks categories by their average Line Net value; ranking by a numeric group-by field ranks categories by the field's value directly.

The example below shows two bar charts using Rank Filters: the top chart shows the Top 5 subcategories by Average Line Net, sorted descending; the bottom chart shows the Bottom 5 subcategories by Net Sales, sorted ascending. The Filters Panel shows the active Rank Filter cards on each widget.

#### Rank Filter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          layout: {},
          widgets: {
            "top-5": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "line_net", aggregation: "sum" }],
              },
              sort: [{ field: { id: "net_sales" }, direction: "desc" }],
              format: {
                title: {
                  enabled: true,
                  text: "Top 5 Subcategories by Line Net (avg)",
                },
              },
            },
            "bottom-5": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              sort: [{ field: { id: "net_sales" }, direction: "asc" }],
              format: {
                title: {
                  enabled: true,
                  text: "Bottom 5 Subcategories by Net Sales",
                },
              },
            },
          },
          widgetLayout: {
            "top-5": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 20 },
            "bottom-5": { xTrack: 0, yTrack: 20, xSpan: 24, ySpan: 20 },
          },
          filter: {
            widget: {
              "top-5": [
                {
                  field: { id: "line_net" },
                  view: { expanded: true },
                  model: {
                    operator: "rank",
                    value: [5, null],
                  },
                },
              ],
              "bottom-5": [
                {
                  field: { id: "net_sales" },
                  view: { expanded: true },
                  model: {
                    operator: "rank",
                    value: [null, 5],
                  },
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["filters"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Rank Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/rank-filter/reactFunctionalTs/)

Rank Filter respects all other active Filters, and ranking is applied after existing Filters. If N exceeds the number of available categories, all available results are shown.

If the Widget changes so the category no longer produces a numeric output, the Rank Filter is cleared and a non-blocking message explains why it was removed.

## Cross-Filtering

Cross-filtering is driven by interacting with a Widget. When values are selected in a Widget, the selection becomes a filter condition that can affect other Widgets on the page. When cross-filtering is active, an additional Cross Filters section appears between Page Filters and Widget Filters.

Cross-filtering is configured per widget and is on by default. Settings can be changed in the [Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#edit-panel). Cross-filtering has three modes:

- **Cross Highlight** - highlights proportional selection in the visualisation (pie, doughnut, bar, and column).
- **Cross Filter** - redraws data under the cross-filter condition.
- **None** - disables cross-filtering.

The example below shows a page with mixed cross-filter settings. The KPI Widgets have cross-filtering disabled - they display totals that reflect all data and do not respond to cross-filter changes. The bar, column, and pie charts use Cross Highlight mode, so a selection shows a proportional highlight without redrawing the data. The line chart uses Cross Filter mode, so it redraws under the cross-filter condition. UK is pre-selected in Net Sales by Region and Mid-Market in Net Sales by Segment to show the Filters Panel and highlight effects on load.

#### Cross-Filtering

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "kpi-net-sales": {
              type: "value",
              dataMapping: { value: [{ id: "net_sales" }] },
              format: {
                caption: { enabled: true, text: "Net Sales" },
                crossFilter: "none",
              },
            },
            "kpi-order-count": {
              type: "value",
              dataMapping: { value: [{ id: "order_count" }] },
              format: {
                caption: { enabled: true, text: "Order Count" },
                crossFilter: "none",
              },
            },
            "kpi-aov": {
              type: "value",
              dataMapping: { value: [{ id: "average_order_value" }] },
              format: {
                caption: { enabled: true, text: "Avg Order Value" },
                crossFilter: "none",
              },
            },
            "net-sales-by-region": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "stores.region" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales by Region" } },
            },
            "net-sales-by-subcategory": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "products.subcategory" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Subcategory" },
              },
            },
            "net-sales-over-time": {
              type: "line-chart",
              dataMapping: {
                categoryKey: [{ id: "orders.order_month" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: { title: { enabled: true, text: "Net Sales over Time" } },
            },
            "net-sales-by-category": {
              type: "pie-chart",
              dataMapping: {
                categoryKey: [{ id: "customers.segment" }],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: { enabled: true, text: "Net Sales by Segment" },
              },
            },
          },
          widgetLayout: {
            "kpi-net-sales": { xTrack: 0, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-order-count": { xTrack: 8, yTrack: 0, xSpan: 8, ySpan: 6 },
            "kpi-aov": { xTrack: 16, yTrack: 0, xSpan: 8, ySpan: 6 },
            "net-sales-over-time": {
              xTrack: 0,
              yTrack: 6,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-subcategory": {
              xTrack: 0,
              yTrack: 24,
              xSpan: 24,
              ySpan: 18,
            },
            "net-sales-by-category": {
              xTrack: 0,
              yTrack: 42,
              xSpan: 12,
              ySpan: 18,
            },
            "net-sales-by-region": {
              xTrack: 12,
              yTrack: 42,
              xSpan: 12,
              ySpan: 18,
            },
          },
          crossFilter: {
            values: {
              "net-sales-by-region": [
                {
                  type: "value",
                  field: { id: "stores.region" },
                  values: ["UK"],
                },
              ],
              "net-sales-by-category": [
                {
                  type: "value",
                  field: { id: "customers.segment" },
                  values: ["Mid-Market"],
                },
              ],
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["filters"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Cross-Filtering](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/cross-filtering/reactFunctionalTs/)

When cross-filtering applies a condition, a read-only, collapsed filter card is shown in the Cross Filters section of the Filters Panel indicating the applied condition. Cross Filters cards can be clicked to put the origin Widget into focus, and the condition can be removed using the 'x' action on the card.

Cross-filtering is designed to be quick and reversible. Clicking the same selection again clears the condition, including when using `^ Ctrl` for multi-select. If no cross-filtering is applied, the Cross Filters section is hidden.

## Filter Widgets

Filter Widgets are on-canvas filter controls that allow report consumers to filter the page using visible controls, without opening the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/react/filters/#filters-panel).

AG Studio supports three types of Filter Widgets:

| Type | Description | Input Requirements |
| --- | --- | --- |
| **List** | A dropdown or list that allows selecting one or more values from available options. | Any categorical or value field, such as product names, regions, or status |
| **Button** | Button-based controls that display distinct values as individual buttons for quick selection. | Any categorical or value field, such as product names, regions, or status |
| **Date** | A date picker that allows selecting a date, date range, or predefined date ranges. | Date or DateTime fields |

Filter Widgets do not update in response to Page and Widget Filters or cross-filter conditions. In [Edit Mode](https://www.ag-grid.com/studio/archive/3.0.0/react/user-interface/#modes), clicking a Filter Widget puts it in focus and exposes its options in the [Filters Panel](https://www.ag-grid.com/studio/archive/3.0.0/react/filters/#filters-panel), where the available options can be customised using a Widget Filter.

When a Filter Widget applies a condition, a read-only card appears in the Page Filters section of the Filters Panel, and the condition can be cleared using the 'x' action, which is equivalent to clearing the Filter Widget selection directly.

The example below uses List Filter Widgets to filter a nuclear dataset. Click values in any filter list to apply a condition and watch the corresponding card appear in the Filters Panel. Switch to Edit mode, click a Filter Widget to put it in focus, and update its options in the Filters Panel to see the available selections being customised.

#### Filter Widgets

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getNuclearDataSource } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "segre-chart",
      widgets: {
        "report-title": {
          type: "text",
          dataMapping: {},
          format: {
            style: {
              text: "Nuclear Wallet Cards - Segrè Chart Visualization",
              typography: { fontWeight: "normal" },
            },
          },
        },
        "element-family-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Element Family" }],
          },
        },
        "stability-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Stability" }],
          },
        },
        "occurrence-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Occurrence" }],
          },
        },
        "decay-mode-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "nuclear-data.Decay Mode" }],
          },
        },
        "nuclides-chart": {
          type: "scatter-chart",
          dataMapping: {
            categoryKey: [
              { id: "nuclear-data.Neutrons (N)", aggregation: "first" },
            ],
            valueKey: [
              { id: "nuclear-data.Atomic Number (Z)", aggregation: "first" },
            ],
            groupByKey: [{ id: "nuclear-data.Element + Atomic Mass (A)" }],
            tooltipKey: [
              { id: "nuclear-data.Element", aggregation: "first" },
              { id: "nuclear-data.Atomic Mass (A)", aggregation: "first" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Chart of Nuclides",
            },
            subtitle: {
              enabled: true,
              text: "A Segrè chart showing isotopes by neutron count and atomic number.",
            },
          },
        },
        "element-grid": {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "nuclear-data.Element + Atomic Mass (A)" },
              { id: "nuclear-data.Element" },
              { id: "nuclear-data.Atomic Number (Z)" },
              { id: "nuclear-data.Atomic Mass (A)" },
              { id: "nuclear-data.Neutrons (N)" },
              { id: "nuclear-data.Half-Life" },
              { id: "nuclear-data.Half-Life (Unit)" },
              { id: "nuclear-data.Spin-Parity" },
              { id: "nuclear-data.Decay Modes" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Nuclear Properties",
            },
            style: {
              theme: { rowHeight: 28 },
            },
          },
        },
      },
      widgetLayout: {
        "report-title": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 4 },
        "element-family-filter": { xTrack: 0, yTrack: 4, xSpan: 6, ySpan: 12 },
        "stability-filter": { xTrack: 0, yTrack: 16, xSpan: 6, ySpan: 9 },
        "occurrence-filter": { xTrack: 0, yTrack: 25, xSpan: 6, ySpan: 6 },
        "decay-mode-filter": { xTrack: 0, yTrack: 31, xSpan: 6, ySpan: 9 },
        "nuclides-chart": { xTrack: 6, yTrack: 4, xSpan: 18, ySpan: 36 },
        "element-grid": { xTrack: 0, yTrack: 40, xSpan: 24, ySpan: 14 },
      },
      filter: {
        page: [],
      },
    },
  ],
  selectedPageId: "segre-chart",
};

let studioApi: AgStudioApi;

async function getStudioProperties(): Promise<AgStudioProperties> {
  const nuclearSource = await getNuclearDataSource();

  return {
    mode: "view",
    initialState,
    data: {
      sources: [nuclearSource],
      relationships: [],
    },
  };
}

const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
const studioProperties = await getStudioProperties();
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Filter Widgets](https://www.ag-grid.com/studio/archive/3.0.0/examples/filters/filter-widgets/typescript/)
